local HELM, NECK, SHOULDER, SHIRT, CHEST, WAIST, LEGS, FEET, WRISTS, HANDS, RING1, RING2, TRINK1, TRINK2, BACK, WEP, OFFHAND = 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17

local ItemUpgradeInfo = LibStub("LibItemUpgradeInfo-1.0")
local Oilvltimer = LibStub("AceAddon-3.0"):NewAddon("MyAddOn", "AceTimer-3.0")

local OTTIL = CreateFrame("Frame");
local oilvlframesw=false;
local OTTIL_Unit="";
local OTilvl=0;
local OTmia=0;
local OTTop=0;	
local Omover=0;
local OTCurrent; -- current raid frame
local OTCurrent2; -- current unit id
-- OT Check Raid Item Level

function ottil(unit)
	if not UnitAffectingCombat("player") then
		OTTIL_Unit=unit;
		if CheckInteractDistance(OTTIL_Unit, 1) and CanInspect(OTTIL_Unit) then
			OTTIL:RegisterEvent("INSPECT_READY");
			NotifyInspect(OTTIL_Unit);
			local htex4 = _G[OTCurrent]:CreateTexture()
			htex4:SetTexture(0,1,1,0.5)
			htex4:SetTexCoord(0, 0.625, 0, 0.6875)
			htex4:SetAllPoints()
			_G[OTCurrent]:SetNormalTexture(htex4)
		else
			_G[OTCurrent]:SetText("|cFFFFFF00"..GetUnitName(OTCurrent2,""):gsub("%-.+", "").."\n|r|cFF00FF00".."failed");
			OILVLCheckUpdate();
		end
	end
end
	
-- Get Raid Frame Item Level
function ORfbIlvl(ounit)
if not UnitAffectingCombat("player") then
	local i=0;
	for i=1, 40 do
		local ntex4 = _G["OILVLRAIDFRAME"..i]:CreateTexture()
		ntex4:SetTexture(0.2,0.2,0.2,0.5)
		ntex4:SetTexCoord(0, 0.625, 0, 0.6875)
		ntex4:SetAllPoints()	
		_G["OILVLRAIDFRAME"..i]:SetNormalTexture(ntex4)
	end

	if IsInRaid() then
		OTCurrent = "OILVLRAIDFRAME"..ounit;		
		OTCurrent2 = "raid"..ounit;
		if GetUnitName(OTCurrent2,"") ~= nil then
			_G[OTCurrent]:SetText("|cFFFFFF00"..GetUnitName(OTCurrent2,""):gsub("%-.+", ""));
			ottil(OTCurrent2);
		end
	elseif IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then
		if ounit == "1" or ounit == 1 then
			OTCurrent = "OILVLRAIDFRAME1";
			OTCurrent2 = "player";
			if GetUnitName(OTCurrent2,"") ~= nil then
				_G[OTCurrent]:SetText("|cFFFFFF00"..GetUnitName(OTCurrent2,""):gsub("%-.+", ""));
				ottil(OTCurrent2);
			end
		else
			OTCurrent = "OILVLRAIDFRAME"..ounit;
			OTCurrent2 = "party"..(ounit-1);
			if GetUnitName(OTCurrent2,"") ~= nil then
				_G[OTCurrent]:SetText("|cFFFFFF00"..GetUnitName(OTCurrent2,""):gsub("%-.+", ""));
				ottil(OTCurrent2);
			end
		end
	elseif IsInGroup(LE_PARTY_CATEGORY_HOME) then
		if ounit == "1"  or ounit == 1 then
			OTCurrent = "OILVLRAIDFRAME1";
			OTCurrent2 = "player";
			if GetUnitName(OTCurrent2,"") ~= nil then
				_G[OTCurrent]:SetText("|cFFFFFF00"..GetUnitName(OTCurrent2,""):gsub("%-.+", ""));
				ottil(OTCurrent2);
			end
		else
			OTCurrent = "OILVLRAIDFRAME"..ounit;
			OTCurrent2 = "party"..(ounit-1);
			if GetUnitName(OTCurrent2,"") ~= nil then
				_G[OTCurrent]:SetText("|cFFFFFF00"..GetUnitName(OTCurrent2,""):gsub("%-.+", ""));
				ottil(OTCurrent2);
			end
		end
	else
		OTCurrent = "OILVLRAIDFRAME1";
		OTCurrent2 = "player";
		if GetUnitName(OTCurrent2,"") ~= nil then
			_G[OTCurrent]:SetText("|cFFFFFF00"..GetUnitName(OTCurrent2,""):gsub("%-.+", ""));
			ottil(OTCurrent2);
		end
	end
end
end

function OILVLCheckUpdate()
if not UnitAffectingCombat("player") then
	for i = 1, 40 do
		if not _G["OILVLRAIDFRAME"..i]:IsShown() then
			break;
		end
		local msg = _G["OILVLRAIDFRAME"..i]:GetText();
		if msg == nil then
			break;
		end		
		msg = msg:gsub("|cFFFFFF00",""):gsub("\n|r|cFF00FF00",":");
		local ochar, ilvl = strsplit(":",msg,2)
		if ilvl == nil then
			ORfbIlvl(i);
			break;
		end
	end
end
end
	
function OVILRefresh()
	local i=0;
	local rnum=0;
	for i = 1, 40 do
		local ntex4 = _G["OILVLRAIDFRAME"..i]:CreateTexture()
		ntex4:SetTexture(0.2,0.2,0.2,0.5)
		ntex4:SetTexCoord(0, 0.625, 0, 0.6875)
		ntex4:SetAllPoints()	
		_G["OILVLRAIDFRAME"..i]:SetNormalTexture(ntex4)	
	end
	if IsInRaid() then
		rnum = GetNumGroupMembers();
		if rnum >= 16 and rnum <= 20 then
			OIVLFRAME:SetWidth(348);
		end
		if rnum >= 21 and rnum <= 25 then
			OIVLFRAME:SetWidth(430);
		end
		if rnum >= 26 and rnum <= 30 then
			OIVLFRAME:SetWidth(512);
		end
		if rnum >= 31 and rnum <= 35 then
			OIVLFRAME:SetWidth(594);
		end
		if rnum >= 36 and rnum <= 40 then
			OIVLFRAME:SetWidth(676);
		end
		for i = rnum+1, 40 do
			_G["OILVLRAIDFRAME"..i]:SetText("");
			_G["OILVLRAIDFRAME"..i]:Hide();
		end
		for i = 1, rnum do
			_G["OILVLRAIDFRAME"..i]:SetText("|cFFFFFF00"..GetUnitName("raid"..i,""):gsub("%-.+", ""));
			_G["OILVLRAIDFRAME"..i]:Show();
		end
	elseif IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then
		rnum = GetNumGroupMembers(LE_PARTY_CATEGORY_INSTANCE)
		for i = rnum, 40 do
			_G["OILVLRAIDFRAME"..i]:SetText("");
			_G["OILVLRAIDFRAME"..i]:Hide();
		end
		OILVLRAIDFRAME1:Show();
		OILVLRAIDFRAME1:SetText("|cFFFFFF00"..GetUnitName("player",""):gsub("%-.+", ""));
		for i = 2, rnum do
			_G["OILVLRAIDFRAME"..i]:SetText("|cFFFFFF00"..GetUnitName("party"..(i-1),""):gsub("%-.+", ""));
			_G["OILVLRAIDFRAME"..i]:Show();
		end
	elseif IsInGroup(LE_PARTY_CATEGORY_HOME) then
		rnum = GetNumGroupMembers(LE_PARTY_CATEGORY_HOME)
		for i = rnum, 40 do
			_G["OILVLRAIDFRAME"..i]:SetText("");
			_G["OILVLRAIDFRAME"..i]:Hide();
		end
		OILVLRAIDFRAME1:Show();
		OILVLRAIDFRAME1:SetText("|cFFFFFF00"..GetUnitName("player",""):gsub("%-.+", ""));
		for i = 2, rnum do
			_G["OILVLRAIDFRAME"..i]:SetText("|cFFFFFF00"..GetUnitName("party"..(i-1),""):gsub("%-.+", ""));
			_G["OILVLRAIDFRAME"..i]:Show();
		end
	else
		for i = 2, 40 do
			_G["OILVLRAIDFRAME"..i]:SetText("");
			_G["OILVLRAIDFRAME"..i]:Hide();
		end
		OILVLRAIDFRAME1:SetText("|cFFFFFF00"..GetUnitName("player",""):gsub("%-.+", ""));
		OIVLFRAME:SetWidth(266);
	end
	Oilvltimer:ScheduleTimer(OILVLCheckUpdate,2);
end

function OSendToTarget()
	local i=0;
	if not UnitExists("target") then 
		return -1;
	end
	SendChatMessage("Item Level:", "WHISPER", nil, UnitName("target"));
	for i = 1, 40 do
		if not _G["OILVLRAIDFRAME"..i]:IsShown() then
			break;
		end
		local msg = _G["OILVLRAIDFRAME"..i]:GetText();
		if msg == nil then
			break;
		end		
		msg = msg:gsub("|cFFFFFF00","");
		msg = msg:gsub("\n|r|cFF00FF00",": ");
		SendChatMessage(msg, "WHISPER", nil, UnitName("target"));		
	end
end

function OSendToParty()
	local i=0;
	SendChatMessage("Item Level:", "PARTY");
	for i = 1, 5 do
		if not _G["OILVLRAIDFRAME"..i]:IsShown() then
			break;
		end
		local msg = _G["OILVLRAIDFRAME"..i]:GetText();
		if msg == nil then
			break;
		end		
		msg = msg:gsub("|cFFFFFF00","");
		msg = msg:gsub("\n|r|cFF00FF00",": ");
		SendChatMessage(msg, "PARTY");
	end
end

function OSendToInstance()
	local i=0;
	SendChatMessage("Item Level:", "INSTANCE_CHAT");
	for i = 1, 5 do
		if not _G["OILVLRAIDFRAME"..i]:IsShown() then
			break;
		end
		local msg = _G["OILVLRAIDFRAME"..i]:GetText();
		if msg == nil then
			break;
		end		
		msg = msg:gsub("|cFFFFFF00","");
		msg = msg:gsub("\n|r|cFF00FF00",": ");
		SendChatMessage(msg, "INSTANCE_CHAT");
	end
end

function OSendToGuild()
	local i=0;
	SendChatMessage("Item Level:", "GUILD");
	for i = 1, 40 do
		if not _G["OILVLRAIDFRAME"..i]:IsShown() then
			break;
		end
		local msg = _G["OILVLRAIDFRAME"..i]:GetText();
		if msg == nil then
			break;
		end		
		msg = msg:gsub("|cFFFFFF00","");
		msg = msg:gsub("\n|r|cFF00FF00",": ");
		SendChatMessage(msg, "GUILD");
	end
end

function OSendToRaid()
	local i=0;
	SendChatMessage("Item Level:", "RAID");
	for i = 1, 40 do
		if not _G["OILVLRAIDFRAME"..i]:IsShown() then
			break;
		end
		local msg = _G["OILVLRAIDFRAME"..i]:GetText();
		if msg == nil then
			break;
		end
		msg = msg:gsub("|cFFFFFF00","");
		msg = msg:gsub("\n|r|cFF00FF00",": ");
		SendChatMessage(msg, "RAID");
	end
end
	
function oilvlframe()
	local f = CreateFrame("Frame", "OIVLFRAME", UIParent, "ButtonFrameTemplate");
	f:SetWidth(676);
	f:SetHeight(305);
	f:SetFrameStrata("TOOLTIP");

-- set moveable and dragable	
	f:SetMovable(true);
	f:EnableMouse(true);
	f:RegisterForDrag("LeftButton");
	f:SetScript("OnDragStart", f.StartMoving);
	f:SetScript("OnDragStop", f.StopMovingOrSizing);

-- Set Title
	f.text = f.text or f:CreateFontString(nil,"ARTWORK", "GameTooltipText");
	f.text:SetAllPoints(true);
	f.text:SetPoint("TOPLEFT",0,-6);
	f.text:SetJustifyH("CENTER");
	f.text:SetJustifyV("TOP");
	f.text:SetTextColor(1,1,1,1);
	f.text:SetText("Item Level");	
	
--background texture	
	local t = f:CreateTexture(nil,"BACKGROUND")
	t:SetTexture(0.1,0.1,0.1,0.5)
	t:SetAllPoints(f)
	f.texture = t
	f:SetPoint("TOPLEFT",15,-60);
	
 --icon
    local icon = f:CreateTexture("$parentIcon", "OVERLAY", nil, -8);
    icon:SetSize(60,60);
    icon:SetPoint("TOPLEFT",-5,7);
    icon:SetTexture("Interface\\FriendsFrame\\Battlenet-Portrait");
    icon:SetTexCoord(0,1,0,1);
    f.icon = icon;
	
--Refresh button
	local button = CreateFrame("Button", "OILVLREFRESH", f)
	button:SetPoint("TOPRIGHT", -6, -35)
	button:SetWidth(60)
	button:SetHeight(22)
	
	button:SetText("Refresh")
	button:SetNormalFontObject("GameFontNormal")
	
	local ntex = button:CreateTexture()
	ntex:SetTexture("Interface/Buttons/UI-Panel-Button-Up")
	ntex:SetTexCoord(0, 0.625, 0, 0.6875)
	ntex:SetAllPoints()	
	button:SetNormalTexture(ntex)
	
	local htex = button:CreateTexture()
	htex:SetTexture("Interface/Buttons/UI-Panel-Button-Highlight")
	htex:SetTexCoord(0, 0.625, 0, 0.6875)
	htex:SetAllPoints()
	button:SetHighlightTexture(htex)
	
	local ptex = button:CreateTexture()
	ptex:SetTexture("Interface/Buttons/UI-Panel-Button-Down")
	ptex:SetTexCoord(0, 0.625, 0, 0.6875)
	ptex:SetAllPoints()
	button:SetPushedTexture(ptex)

	button:RegisterForClicks("LeftButtonDown");
	button:SetScript("OnClick", function(self, button) OVILRefresh() end);

--Party button
	local button6 = CreateFrame("Button", "OILVLParty", f)
	button6:SetPoint("TOPRIGHT", -68, -35)
	button6:SetWidth(60)
	button6:SetHeight(22)
	
	button6:SetText("Party")
	button6:SetNormalFontObject("GameFontNormal")
	
	local ntex6 = button6:CreateTexture()
	ntex6:SetTexture("Interface/Buttons/UI-Panel-Button-Up")
	ntex6:SetTexCoord(0, 0.625, 0, 0.6875)
	ntex6:SetAllPoints()	
	button6:SetNormalTexture(ntex6)
	
	local htex6 = button6:CreateTexture()
	htex6:SetTexture("Interface/Buttons/UI-Panel-Button-Highlight")
	htex6:SetTexCoord(0, 0.625, 0, 0.6875)
	htex6:SetAllPoints()
	button6:SetHighlightTexture(htex6)
	
	local ptex6 = button6:CreateTexture()
	ptex6:SetTexture("Interface/Buttons/UI-Panel-Button-Down")
	ptex6:SetTexCoord(0, 0.625, 0, 0.6875)
	ptex6:SetAllPoints()
	button6:SetPushedTexture(ptex6)

	button6:RegisterForClicks("LeftButtonDown");
	button6:SetScript("OnClick", function(self, button) OSendToParty() end);

--Target button
	local button7 = CreateFrame("Button", "OILVLTarget", f)
	button7:SetPoint("TOPRIGHT", -130, -35)
	button7:SetWidth(60)
	button7:SetHeight(22)
	
	button7:SetText("Target")
	button7:SetNormalFontObject("GameFontNormal")
	
	local ntex7 = button7:CreateTexture()
	ntex7:SetTexture("Interface/Buttons/UI-Panel-Button-Up")
	ntex7:SetTexCoord(0, 0.625, 0, 0.6875)
	ntex7:SetAllPoints()	
	button7:SetNormalTexture(ntex7)
	
	local htex7 = button7:CreateTexture()
	htex7:SetTexture("Interface/Buttons/UI-Panel-Button-Highlight")
	htex7:SetTexCoord(0, 0.625, 0, 0.6875)
	htex7:SetAllPoints()
	button7:SetHighlightTexture(htex7)
	
	local ptex7 = button7:CreateTexture()
	ptex7:SetTexture("Interface/Buttons/UI-Panel-Button-Down")
	ptex7:SetTexCoord(0, 0.625, 0, 0.6875)
	ptex7:SetAllPoints()
	button7:SetPushedTexture(ptex7)

	button7:RegisterForClicks("LeftButtonDown");
	button7:SetScript("OnClick", function(self, button) OSendToTarget() end);
	
--Instance button
	local button5 = CreateFrame("Button", "OILVLINSTANCE", f)
	button5:SetPoint("BOTTOMLEFT", 3, 3)
	button5:SetWidth(80)
	button5:SetHeight(22)
	
	button5:SetText("Instance")
	button5:SetNormalFontObject("GameFontNormal")
	
	local ntex5 = button5:CreateTexture()
	ntex5:SetTexture("Interface/Buttons/UI-Panel-Button-Up")
	ntex5:SetTexCoord(0, 0.625, 0, 0.6875)
	ntex5:SetAllPoints()	
	button5:SetNormalTexture(ntex5)
	
	local htex5 = button5:CreateTexture()
	htex5:SetTexture("Interface/Buttons/UI-Panel-Button-Highlight")
	htex5:SetTexCoord(0, 0.625, 0, 0.6875)
	htex5:SetAllPoints()
	button5:SetHighlightTexture(htex5)
	
	local ptex5 = button5:CreateTexture()
	ptex5:SetTexture("Interface/Buttons/UI-Panel-Button-Down")
	ptex5:SetTexCoord(0, 0.625, 0, 0.6875)
	ptex5:SetAllPoints()
	button5:SetPushedTexture(ptex5)

	button5:RegisterForClicks("LeftButtonDown");
	button5:SetScript("OnClick", function(self, button) OSendToInstance() end);

-- Guild button
	local button2 = CreateFrame("Button", "OILVLGUILD", f)
	button2:SetPoint("BOTTOMLEFT", 85, 3)
	button2:SetWidth(80)
	button2:SetHeight(22)
	
	button2:SetText("Guild")
	button2:SetNormalFontObject("GameFontNormal")
	
	local ntex2 = button2:CreateTexture()
	ntex2:SetTexture("Interface/Buttons/UI-Panel-Button-Up")
	ntex2:SetTexCoord(0, 0.625, 0, 0.6875)
	ntex2:SetAllPoints()	
	button2:SetNormalTexture(ntex2)
	
	local htex2 = button2:CreateTexture()
	htex2:SetTexture("Interface/Buttons/UI-Panel-Button-Highlight")
	htex2:SetTexCoord(0, 0.625, 0, 0.6875)
	htex2:SetAllPoints()
	button2:SetHighlightTexture(htex2)
	
	local ptex2 = button2:CreateTexture()
	ptex2:SetTexture("Interface/Buttons/UI-Panel-Button-Down")
	ptex2:SetTexCoord(0, 0.625, 0, 0.6875)
	ptex2:SetAllPoints()
	button2:SetPushedTexture(ptex2)

	button2:RegisterForClicks("LeftButtonDown");
	button2:SetScript("OnClick", function(self, button) OSendToGuild()	end);
	
-- Raid button
	local button3 = CreateFrame("Button", "OILVLRAID", f)
	button3:SetPoint("BOTTOMLEFT", 167, 3)
	button3:SetWidth(80)
	button3:SetHeight(22)
	
	button3:SetText("Raid")
	button3:SetNormalFontObject("GameFontNormal")
	
	local ntex3 = button3:CreateTexture()
	ntex3:SetTexture("Interface/Buttons/UI-Panel-Button-Up")
	ntex3:SetTexCoord(0, 0.625, 0, 0.6875)
	ntex3:SetAllPoints()	
	button3:SetNormalTexture(ntex3)
	
	local htex3 = button3:CreateTexture()
	htex3:SetTexture("Interface/Buttons/UI-Panel-Button-Highlight")
	htex3:SetTexCoord(0, 0.625, 0, 0.6875)
	htex3:SetAllPoints()
	button3:SetHighlightTexture(htex3)
	
	local ptex3 = button3:CreateTexture()
	ptex3:SetTexture("Interface/Buttons/UI-Panel-Button-Down")
	ptex3:SetTexCoord(0, 0.625, 0, 0.6875)
	ptex3:SetAllPoints()
	button3:SetPushedTexture(ptex3)

	button3:RegisterForClicks("LeftButtonDown");
	button3:SetScript("OnClick", function(self, button) OSendToRaid()	end);
	
-- Party / Raid Frame
	local rfb=1; -- raid frame button
	local b4i=0;
	local b4j=0;
	for b4j = 1, 8 do
		for b4i = 1, 5 do
			local button4 = CreateFrame("Button", "OILVLRAIDFRAME"..rfb, f, "SecureActionButtonTemplate")
			button4:SetPoint("TOPLEFT", 10+(b4j-1)*82, -66-(b4i-1)*42)
			button4:SetWidth(80)
			button4:SetHeight(40)	
			button4:SetText("")
			button4:SetNormalFontObject("GameFontNormal")			
	
			local ntex4 = button4:CreateTexture()
			ntex4:SetTexture(0.2,0.2,0.2,0.5)
			ntex4:SetTexCoord(0, 0.625, 0, 0.6875)
			ntex4:SetAllPoints()	
			button4:SetNormalTexture(ntex4)
	
			local htex4 = button4:CreateTexture()
			htex4:SetTexture(0,0,1,0.5)
			htex4:SetTexCoord(0, 0.625, 0, 0.6875)
			htex4:SetAllPoints()
			button4:SetHighlightTexture(htex4)
	
			local ptex4 = button4:CreateTexture()
			ptex4:SetTexture(0,1,1,0.5)
			ptex4:SetTexCoord(0, 0.625, 0, 0.6875)
			ptex4:SetAllPoints()
			button4:SetPushedTexture(ptex4)
		
			button4:RegisterForClicks("LeftButtonDown");
			button4:SetScript("OnClick", function(self, button) ORfbIlvl(self:GetName():gsub("OILVLRAIDFRAME", "").."")	end);

			rfb = rfb + 1;
		end
	end	
-- Refresh
	oilvlframesw=true;
	OVILRefresh();
	f:SetScale(0.8);
	f:Hide();
	tinsert(UISpecialFrames,"OIVLFRAME");
end

function OGetComA()
	local OSTAT = {
	--	[#] = {LFR,Flex,{10N,25N},{10H,25H}}
		[1]	= {8549,8550,{8551,8552},{8553,8554}},
		[2]	= {8555,8556,{8557,8558},{8559,8560}},
		[3]	= {8561,8562,{8563,8564},{8565,8566}},
		[4]	= {8567,8568,{8569,8570},{8571,8573}},
		[5]	= {8574,8575,{8576,8577},{8578,8579}},
		[6]	= {8580,8581,{8582,8583},{8584,8585}},
		[7]	= {8586,8587,{8588,8589},{8590,8591}},
		[8]	= {8593,8594,{8595,8596},{8597,8598}},
		[9]	= {8599,8600,{8601,8602},{8603,8604}},
		[10]= {8605,8606,{8608,8609},{8610,8612}},
		[11]= {8614,8615,{8616,8617},{8618,8619}},
		[12]= {8620,8621,{8622,8623},{8624,8625}},
		[13]= {8626,8627,{8628,8629},{8630,8631}},
		[14]= {8632,8634,{8635,8636},{8637,8638}},
	}
	
	local i=0;
	local omatch=false;
	for i = 2, GameTooltip:NumLines() do
		local msg = _G["GameTooltipTextLeft"..i]:GetText();
		if msg then
			msg = msg:find("SoO Progression");
		end
		if msg then
			omatch=true;
			break;
		end
	end	
	if not omatch then
		GameTooltip:SetHeight(GameTooltip:GetHeight()+15);
		GameTooltip:AddLine("SoO Progression:");
	end
	local op=0;
	for i = 1, 14 do
		if (GetComparisonStatistic(OSTAT[i][4][1]) ~= "--") or (GetComparisonStatistic(OSTAT[i][4][2]) ~= "--") then
			op = op + 1;
		end
	end
	if not omatch then
		GameTooltip:SetHeight(GameTooltip:GetHeight()+15);
		GameTooltip:AddLine("|cFF00FF00"..op.."/14M");
	end
	op=0;
	for i = 1, 14 do
		if (GetComparisonStatistic(OSTAT[i][3][1]) ~= "--") or (GetComparisonStatistic(OSTAT[i][3][2]) ~= "--") then
			op = op + 1;
		end
	end
	if not omatch then
		GameTooltip:SetHeight(GameTooltip:GetHeight()+15);
		GameTooltip:AddLine("|cFF00FF00"..op.."/14H");
	end
	op=0;
	for i = 1, 14 do
		if (GetComparisonStatistic(OSTAT[i][2]) ~= "--") or (GetComparisonStatistic(OSTAT[i][2]) ~= "--") then
			op = op + 1;
		end
	end
	if not omatch then
		GameTooltip:SetHeight(GameTooltip:GetHeight()+15);
		GameTooltip:AddLine("|cFF00FF00"..op.."/14N");
	end
	op=0;
	for i = 1, 14 do
		if (GetComparisonStatistic(OSTAT[i][1]) ~= "--") or (GetComparisonStatistic(OSTAT[i][1]) ~= "--") then
			op = op + 1;
		end
	end
	if not omatch then
		GameTooltip:SetHeight(GameTooltip:GetHeight()+15);
		GameTooltip:AddLine("|cFF00FF00"..op.."/14L");
	end
	OTTIL:UnregisterEvent("INSPECT_ACHIEVEMENT_READY");
	ClearAchievementComparisonUnit();
end	

function OTgathertil(guid, unitid)
	local totalIlvl, avgIlvl = 0
	local iter_min, iter_max = 0
	local itemLevel = 0
	local equipType = 0
	local twoHander = nil
	local mia = 0;
	local count = 0
	for i = 1,17 do
		if(i ~= SHIRT) then
			local item = GetInventoryItemLink(unitid, i)
			if(item) then
				local upgradeID = ItemUpgradeInfo:GetUpgradeID(item)
				local upgrade = ItemUpgradeInfo:GetCurrentUpgrade(upgradeID)
				_,_,_,itemLevel,_,_,_,_,equipType = GetItemInfo(item)

				if(itemLevel) then
					count = count + 1
					if(i == WEP) then
						if(equipType == "INVTYPE_2HWEAPON" or equipType == "INVTYPE_RANGED" or equipType == "INVTYPE_RANGEDRIGHT") then
							twoHander = 1
						end
					end

					if(upgrade == 1) then 
						itemLevel = itemLevel + 4
					elseif(upgrade == 2) then
						itemLevel = itemLevel + 8
					elseif(upgrade == 3) then
						itemLevel = itemLevel + 12
					elseif(upgrade == 4) then
						itemLevel = itemLevel + 16
					end
					totalIlvl = totalIlvl + itemLevel
				end
			end
		end
	end
	if count < 15 then
		mia = 1;
	end
	if((count == 15) and twoHander) then
		avgIlvl = math.floor(totalIlvl / count)
	elseif((count == 16) and not twoHander) then
		avgIlvl = math.floor(totalIlvl / count)
	elseif((count == 16) and twoHander) then
		avgIlvl = math.floor(totalIlvl / 16)
	else
		avgIlvl = math.floor(totalIlvl / 15)
	end
return avgIlvl, mia;
end

function OTInspect(self,event,unit)
	if UnitAffectingCombat("player") == false and event ~= "PLAYER_LEAVING_WORLD" then
		if event == "INSPECT_READY" then
			if OTTIL_Unit ~= "" then
				if CheckInteractDistance(OTTIL_Unit, 1) then
					OTilvl, OTmia = OTgathertil(UnitGUID("OTTIL_Unit"),OTTIL_Unit)
					if (OTmia == 0) then 
						OTTIL_Unit="";
						local ntex4 = _G[OTCurrent]:CreateTexture()
						ntex4:SetTexture(0.2,0.2,0.2,0.5)
						ntex4:SetTexCoord(0, 0.625, 0, 0.6875)
						ntex4:SetAllPoints()	
						_G[OTCurrent]:SetNormalTexture(ntex4)
						if GetUnitName(OTCurrent2,"") ~= nil then
							_G[OTCurrent]:SetText("|cFFFFFF00"..GetUnitName(OTCurrent2,""):gsub("%-.+", "").."\n|r|cFF00FF00"..OTilvl);
						end
					else
						ottil(OTTIL_Unit);
					end
				else
					OTTIL_Unit="";
					local ntex4 = _G[OTCurrent]:CreateTexture()
					ntex4:SetTexture(0.2,0.2,0.2,0.5)
					ntex4:SetTexCoord(0, 0.625, 0, 0.6875)
					ntex4:SetAllPoints()	
					_G[OTCurrent]:SetNormalTexture(ntex4)
					if GetUnitName(OTCurrent2,"") ~= nil then
						_G[OTCurrent]:SetText("|cFFFFFF00"..GetUnitName(OTCurrent2,""):gsub("%-.+", "").."\n|r|cFFFF0000failed");
					end
				end				
				Oilvltimer:ScheduleTimer(OILVLCheckUpdate,2);
			end
			-- GameTooltip		
			if (Omover ==1) then
				Omover=0;				
				if CheckInteractDistance("mouseover", 1) then
					local OTilvl2, OTmia2 = OTgathertil(UnitGUID("mouseover"),"mouseover")
					if (OTmia2 == 0) then
						local i=0;
						local omatch=false;
						for i = 2, GameTooltip:NumLines() do
							local msg = _G["GameTooltipTextLeft"..i]:GetText();
							if msg then
								msg = msg:find("Item Level");
							end
							if msg then
								_G["GameTooltipTextLeft"..i]:SetText("|cFFFFFF00Item Level: |r|cFF00FF00"..OTilvl2);
								omatch=true;
								break;
							end
						end	
						if not omatch then
							GameTooltip:SetHeight(GameTooltip:GetHeight()+10);
							GameTooltip:AddLine("|cFFFFFF00Item Level: |r|cFF00FF00"..OTilvl2);	
						end
					else
						local i=0;
						local omatch=false;
						for i = 2, GameTooltip:NumLines() do
							local msg = _G["GameTooltipTextLeft"..i]:GetText();
							if msg then
								msg = msg:find("Item Level");
							end						
							if msg then
								_G["GameTooltipTextLeft"..i]:SetText("|cFFFFFF00Item Level: |r|cFFFF0000"..OTilvl2);
								omatch=true;
								break;
							end
						end	
						if not omatch then
							GameTooltip:SetHeight(GameTooltip:GetHeight()+10);
							GameTooltip:AddLine("|cFFFFFF00Item Level: |r|cFFFF0000"..OTilvl2);	
						end
					end
				end
			end
			OTTIL:UnregisterEvent("INSPECT_READY")
			ClearInspectPlayer()
		end
		if event == "PLAYER_ENTERING_WORLD" then
			if not oilvlframesw then 
				oilvlframe(); 
			else
				OVILRefresh();
			end
		end
		if event == "INSPECT_ACHIEVEMENT_READY" then
			OGetComA();
		end
		if event == "GROUP_ROSTER_UPDATE" then
			OVILRefresh();
		end
		if event == "RAID_ROSTER_UPDATE" then
			OVILRefresh();
		end
	end
end
	-- Set GameTooltip	
function OMouseover()
	if not UnitAffectingCombat("player") then
		if CheckInteractDistance("mouseover", 1) and CanInspect("mouseover") and Omover == 0 then
			OTTIL:RegisterEvent("INSPECT_READY");
			NotifyInspect("mouseover");
			Omover=1;				
			SetAchievementComparisonUnit("mouseover");
			OTTIL:RegisterEvent("INSPECT_ACHIEVEMENT_READY")
		end
	end
end

SLASH_OILVL_OILVL1 = "/oilvl"

SlashCmdList["OILVL_OILVL"] = function()
		Oilvltimer:ScheduleTimer(OILVLCheckUpdate,2);
		OIVLFRAME:Show();		
	end

OTTIL:SetScript("OnEvent", OTInspect)
OTTIL:RegisterEvent("PLAYER_ENTERING_WORLD");
OTTIL:RegisterEvent("PLAYER_LEAVING_WORLD");
OTTIL:RegisterEvent("GROUP_ROSTER_UPDATE");
OTTIL:RegisterEvent("RAID_ROSTER_UPDATE");

GameTooltip:HookScript("OnTooltipSetUnit", function() Oilvltimer:ScheduleTimer(OMouseover,1); end);